require 'rails/generators'
module Blade
  module Setting
    module ControllerTemplate

      class InstallGenerator < Rails::Generators::Base
        source_root File.expand_path('../templates', __FILE__)

        def create_view_file(path, content)
          create_file path, content
        end

        def add_routes(args,namespace)
          route("
namespace :#{namespace} do
    resources :#{args}
end
")
        end

        def add_gem(gem_name)
           gem gem_name
           Bundler.with_clean_env do
             run "bundle install"
           end
        end

        class << self
          def controller_tmp(model_class,name, namespace)
            model = model_class.name
            arg1 =  name
            args = arg1.pluralize
            prefix = namespace.classify
            template = <<File

class #{prefix}::#{model.pluralize}Controller < ApplicationController
  def index
    @response, @#{args} = #{model}Service.query_by_params params
  end

  def create
    @response, @#{arg1} = #{model}Service.create_by_params params
  end

  def update
    @response, @#{arg1} = #{model}Service.update_by_params params
  end

  def destroy
    @response = #{model}Service.delete_by_params params
  end

end

File
          end
        end

      end




    end
  end
end